; -*- Scheme -*-

(load "fold-layout.scm")

(define-macro (assert-equal X Y)
  (let ((x (gensym)) (y (gensym)))
    `(let ((,x ,X) (,y ,Y))
       (or (equal? ,x ,y)
           (begin
             (newline)
             (write ',X)
             (display " = ")
             (write ,x)
             (newline)
             (newline)
             (write ',Y)
             (display " = ")
             (write ,y)
             (newline)
             (newline)
             (error "not equal"))))))

(define-macro (assert X)
  (let ((x (gensym)))
    `(let ((,x ,X))
       (or ,x
           (error "not true:" ',X "=" ,x)))))

(define test-doc
  '(presentation
    (@ (width 1024)
       (height 768)
       (title-style "font-family:Georgia")
       (title-height 72)
       (title-baseline-y 96)
       (title-x 48)
       (text-height 64)
       (text-style "font-family:Georgia")
       (text-upper-left-x 96)
       (text-upper-left-y 216))
    (slide
     (@ (title "Declarative interface"))
     (p "The declarative interface"
        "lets you be more concise"
        "when making the slides."))
    (slide
     (@ (title "Still cumbersome"))
     (p "Parentheses are still"
        "cumbersome."))))

(define (identity-layout tree)
  (fold-layout
   tree
   `((*default*
      . ,(lambda (tag params old-layout layout kids)
           (values layout
                   (if (null? (car params))
                       (cons tag kids)
                       (cons* tag (cons '@ (car params)) kids)))))
     (*text*
      . ,(lambda (text params layout)
           (values layout text))))
   '()
   (cons 0 0)))

(define-macro (accept expr)
  `(call-with-values
       (lambda () ,expr)
     (lambda values values)))

(assert-equal (accept (identity-layout test-doc))
              (list test-doc (cons 0 0)))
(display "all tests pass")(newline)